import { cos } from "mathjs";

export function ZhongRun(Department, money, materianame, name, CompositeTable, quantity, model, Unitprice, code, units) {
    money.forEach(element => {
        //材料名称
        element.materianame = ''
        element.index = element.r
        //部门
        element.v.Department = ''
        //数量
        element.quantity = ''
        //型号
        element.model = ''
        //单价
        element.Unitprice = ''
        element.code = ''
        element.v.name = ''
        element.units = ''
    });
    for (let i = 0; i < money.length; i++) {
        //materianame 材料名称
        if (money[i].r == materianame[i].r) {
            money[i].materianame = materianame[i].v.v;
        }
        //部门列
        if (money[i].r == Department[i].r) {
            money[i].v.Department = Department[i].v.v;
        }
        //来源分类列
        if (money[i].r == name[i].r) {
            money[i].v.name = name[i].v.v;
        }
        if (money[i].r == quantity[i].r) {
            money[i].quantity = quantity[i].v.v;
        }
        if (money[i].r == model[i].r) {
            money[i].model = model[i].v.v;
        }
        if (money[i].r == Unitprice[i].r) {
            money[i].Unitprice = Unitprice[i].v.v;
        }
        if (money[i].r == code[i].r) {
            money[i].code = code[i].v.v;
        }
        if (money[i].r == units[i].r) {
            money[i].units = units[i].v.v;
        }
    }
    let moneys = JSON.stringify(money)
    let Secondcoloumn = money.filter(item => item.v && item.v.Department == '净化分厂' && (item.materianame == '硫酸' || item.materianame == '洗油'))
    const SecondHalf = CompositeTable[0].celldata.flat().filter(item => item.c && item.c > 12 && item.v.v)
    const Secondrow = CompositeTable[0].celldata.flat().filter(item => item.r && item.r > 40 && item.v.v && item.c == 0)
    money.forEach(item => {
        SecondHalf.forEach(obj => {
            if (obj.v.v == item.v.Department) {
                item.r = obj.r
            }
            if (obj.v.v.includes(item.v.name)) {
                item.c = obj.c
            }
        })
    })
    let seen = new Map()
    let duplicateData = []
    money.forEach((obj) => {
        let key = obj.r + ',' + obj.c;
        if (seen.has(key)) {
            let existingObj = seen.get(key);
            existingObj.v.v = Number(existingObj.v.v) + Number(obj.v.v);
            existingObj.v.m = existingObj.v.v.toString();
            existingObj.index.push(obj.index);
        } else {
            obj.index = [obj.index];
            seen.set(key, obj);
        }
    });
    seen.forEach(obj => {
        if (Math.abs(obj.v.v) > 0 || parseInt(obj.v.m) > 0) {
            duplicateData.push(obj);
        }
    });
    duplicateData = duplicateData.map(item => {
        return {
            ...item,
            v: {
                ...item.v,
                v: isNaN(item.v.v) ? item.v.v : Number(item.v.v).toFixed(2),
                m: Number(item.v.m).toFixed(2)
            }
        };
    });
    for (let i = 0; i < duplicateData.length; i++) {
        //     // 对比 c 和 r 是否与 CompositeTable[0]["celldata"] 中相应对象相同
        for (let k = 0; k < CompositeTable[0]["celldata"].length; k++) {
            if (duplicateData[i].r === CompositeTable[0]["celldata"][k].r && duplicateData[i].c === CompositeTable[0]["celldata"][k].c) {
                // 如果相同，则进行替换
                CompositeTable[0]["celldata"][k] = duplicateData[i];
            }
        }
    }
    function mergeAndSum(data) {
        // 创建一个空对象用于存储合并后的结果
        let mergedData = {};

        // 遍历原始数据数组
        data.forEach(item => {
            // 生成合并的键，即使用指定属性的值拼接起来作为键
            let key = `${item.v.Department}-${item.v.name}-${item.materianame}-${item.model}-${item.Unitprice}`;

            // 如果已经存在该键，则将 v.v 和 quantity 相加
            if (mergedData[key]) {
                mergedData[key].v.v = (parseFloat(mergedData[key].v.v) + parseFloat(item.v.v)).toFixed(2);
                mergedData[key].quantity = parseInt(mergedData[key].quantity) + parseInt(item.quantity);
            } else {
                // 否则，将当前条目添加到 mergedData 中
                mergedData[key] = {
                    ...item,
                    v: { ...item.v }
                };
            }
        });
        // 将合并后的结果对象转换为数组并返回
        return Object.values(mergedData);
    }
    // 调用函数进行合并并相加
    let mergedData = mergeAndSum(JSON.parse(moneys));
    // 输出结果
    mergedData = mergedData.filter(obj => obj.materianame && obj.materianame == '液体氢氧化钠')
    mergedData.forEach(item => {
        item.index = true
    })
    Secondrow.forEach(item => {
        let matched = false;
        mergedData.forEach(obj => {
            if (item.v.v === obj.v.Department && !matched && obj.index) {
                obj.r = item.r;
                matched = true;
                obj.index = false
            }
        });
    });
    // 创建 Fusion 对象的函数
    function createFusionObject(row, item, column) {
        return {
            "r": row,
            "c": column,
            "v": {
                "ct": {
                    "fa": "@",
                    "t": "g/n"
                },
                "fs": 8,
                "ff": "微软雅黑",
                "tb": 2,
                "v": item,
                "qp": 1,
                "m": item
            }
        };
    }
    // 遍历 mergedData，生成所有 Fusion 对象
    const fusionList = mergedData.map(item => [
        createFusionObject(item.r, item.code, 4),
        createFusionObject(item.r, item.materianame, 5),
        createFusionObject(item.r, item.model, 6),
        createFusionObject(item.r, item.units, 7),
        createFusionObject(item.r, item.quantity, 8),
        createFusionObject(item.r, item.Unitprice, 9),
        createFusionObject(item.r, item.v.v, 10)
    ]);
    const celldata = CompositeTable[0]["celldata"]
    // 将所有 Fusion 对象推送到  CompositeTable[0]["celldata"]
    fusionList.forEach(fusionArray => {
        fusionArray.forEach(fusion => celldata.push(fusion));
    });
    Secondcoloumn.forEach(item => {
        if (item.materianame == '硫酸') {
            item.materianame = '净化分厂硫酸'
        }
        if (item.materianame == '洗油') {
            item.materianame = '净化分厂洗油'
        }
    })
    Secondcoloumn.forEach(item => {
        CompositeTable[0].celldata.forEach(obj => {
            if (obj.v && obj.v.v && obj.v.v.includes(item.materianame)) {
                item.r = obj.r
            }
            if (obj.v && obj.v.v && obj.v.v.includes(item.v.name)) {
                item.c = obj.c
            }
        })
    })
    let seenS = new Map()
    let duplicateDataS = []
    Secondcoloumn.forEach((obj) => {
        let key = obj.r + ',' + obj.c;
        if (seenS.has(key)) {
            let existingObj = seenS.get(key);
            existingObj.v.v = Number(existingObj.v.v) + Number(obj.v.v);
            existingObj.v.m = existingObj.v.v.toString();
            existingObj.index.push(obj.index);
        } else {
            obj.index = [obj.index];
            seenS.set(key, obj);
        }
    });
    seenS.forEach(obj => {
        if (Math.abs(obj.v.v) > 0 || parseInt(obj.v.m) > 0) {
            duplicateDataS.push(obj);
        }
    });
    duplicateDataS = duplicateDataS.map(item => {
        return {
            ...item,
            v: {
                ...item.v,
                v: isNaN(item.v.v) ? item.v.v : Number(item.v.v).toFixed(2),
                m: Number(item.v.m).toFixed(2)
            }
        };
    });
    for (let i = 0; i < duplicateDataS.length; i++) {
        //     // 对比 c 和 r 是否与 CompositeTable[0]["celldata"] 中相应对象相同
        for (let k = 0; k < CompositeTable[0]["celldata"].length; k++) {
            if (duplicateDataS[i].r === CompositeTable[0]["celldata"][k].r && duplicateDataS[i].c === CompositeTable[0]["celldata"][k].c) {
                // 如果相同，则进行替换
                CompositeTable[0]["celldata"][k] = duplicateDataS[i];
            }
        }
    }
    let duplicateDatas = {
        duplicateData: duplicateData,
        CompositeTable: CompositeTable
    }
    return duplicateDatas

}